
// Version G3PTD modifiée pour afficheur LCD 2x16 et suppression du by-pass.

#include <Encoder.h>
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x3F,8,2); // Change adress if needed
Encoder enc(3,2);                // Interrupt pins

// Assignments:
float LCDdata = 0;  // 0 to 31.5 Data for LCD
int AttenData = 0;  // 0 to 63 data for the attenuator
int changerate =4;
long lastPos = 0;
  
void setup() 
{
  lcd.home();
  lcd.begin();
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("  Attenuateur   ");
  lcd.setCursor(0,1);
  lcd.print(" -1.5 a -30 dBm ");
  delay(3000);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print("  Attenuation:  ");
}
 
// The following subroutine sends data to the LCD
void printToLCD(float)
{
    lcd.setCursor(5,1);    
    lcd.print(LCDdata, 1);   // one decimal place only
    lcd.print(" dB");
    lcd.print("               ");
}
 
void loop() 
{
// Send the attenuator value to Port B. (Bit 0 is for 0.5dB steps,
// so six bits are needed.) D8 to 13 go to attenuator V1 to V6
DDRB = B00111111;
PORTB = AttenData;

// ENCODER SECTION 
// Read encoder. AttenData is limited to between 0 and 63
  long newPos = enc.read() /changerate;
  if (newPos != lastPos)  // then encoder has moved
    {
      if (newPos < lastPos) 
    { if (AttenData > 0) AttenData--; 
    } 
      else 
    { if (AttenData < 63) AttenData++; 
    }
    lastPos = newPos;
    }
 
// AttenData (0 to 63) is divided by two to get the 0 to 31.5 for the LCD.
   LCDdata = AttenData / 2.0;
// Attendata is an int. the decimal 2.0 forces a floating point calculation.
// Now add 2dB offset to allow for the insertion loss of about 1.5dB,
// which I have padded up to 2dB.
   LCDdata = LCDdata + 0;
// And display it.  
   printToLCD(AttenData); 
}
